#!/bin/bash

lcd_out=./usb2blitboard
dev='eth1:'
last_in_bytes='0'
last_out_bytes='0'

#---------------------------------------------------------------------
function my_format () 
{
    # 1.Uebergabeparameter ist die Zahl
    zahl=$1
    # Vorsatzzeichen und Teiler bestimmen
    if [ $zahl -gt 999999999 ] ; then 
	t=1000000000
	e=G
    else
	if [ $zahl -gt 999999 ] ; then
	    t=1000000
	    e=M
	else
	    if [ $zahl -gt 999 ] ; then
		t=1000
		e=K
	    else    
		# gleich ausgeben, es muss nichts formatiert werden
		printf "%5d " $zahl
		return
	    fi
	fi
    fi
    # Runden und ganzzahligen Teil berechnen
    z1=$((($zahl+($t/20))/$t))
    # Rest auf eine Stelle berechnen
    z2=$(((($zahl+($t/20))%$t)/($t/10)))
    # und ausgeben
    printf "%3d.%1d%s" $z1 $z2 $e
    return
}

#---------------------------------------------------------------------
function net() {
    # /proc/net/dev auslesen und Daten fuer entspr. NIC ermitteln
    zeile=`cat /proc/net/dev | grep $dev | sed s/$dev// | sed s/^" "*// | sed s/"  "*/,/g`
    in_bytes=`echo $zeile | cut -d , -f 1`
    out_bytes=`echo $zeile | cut -d , -f 9`
    o_in_bytes=`my_format $in_bytes`
    o_out_bytes=`my_format $out_bytes`
    # Uebertragungsgeschwindigkeit ausrechnen
    in_rate=$(($in_bytes - $last_in_bytes))
    out_rate=$(($out_bytes - $last_out_bytes))
    o_in_rate=`my_format $in_rate`
    o_out_rate=`my_format $out_rate`
	#...und ausgeben
	$lcd_out lcd_clear
	$lcd_out lcd_out_text 1 1 io:$o_in_bytes $o_out_bytes
	$lcd_out lcd_out_text 2 1 io:$o_in_rate $o_out_rate
	#...ein paar Werte merken
    last_in_bytes=$in_bytes
    last_out_bytes=$out_bytes 
} 


#---------------------------------------------------------------------------------
#---------------------------------------------------------------------------------
$lcd_out lcd_intern 0
$lcd_out lcd_backlight 1
while [ 0 -lt 1 ]
do
	$lcd_out led 1
	net
	sleep 1
	$lcd_out led 0
	net
	sleep 1
done

